<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-backtrace/cli/icecap-show-backtrace/src/main.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>main.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_show_backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_show_backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_show_backtrace/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::fs::File</span>;

<span class="kw">use</span> <span class="ident">addr2line::Context</span>;
<span class="kw">use</span> <span class="ident">clap</span>::{<span class="ident">App</span>, <span class="ident">Arg</span>};
<span class="kw">use</span> <span class="ident">fallible_iterator::FallibleIterator</span>;
<span class="kw">use</span> <span class="ident">gimli::read::Reader</span>;
<span class="kw">use</span> <span class="ident">memmap::Mmap</span>;

<span class="kw">use</span> <span class="ident">icecap_backtrace_types::Backtrace</span>;

<span class="comment">// TODO handle inlining better (see TODOs scattered throughout this file)</span>

<span class="kw">fn</span> <span class="ident">main</span>() {
    <span class="kw">let</span> <span class="ident">matches</span> <span class="op">=</span> <span class="ident">App::new</span>(<span class="string">&quot;&quot;</span>)
        .<span class="ident">arg</span>(<span class="ident">Arg::from_usage</span>(<span class="string">&quot;-f --file=[ELF]&quot;</span>))
        .<span class="ident">arg</span>(<span class="ident">Arg::from_usage</span>(<span class="string">&quot;&lt;raw_backtrace&gt;&quot;</span>))
        .<span class="ident">get_matches</span>();
    <span class="kw">let</span> <span class="ident">bt_hex</span> <span class="op">=</span> <span class="ident">matches</span>.<span class="ident">value_of</span>(<span class="string">&quot;raw_backtrace&quot;</span>).<span class="ident">unwrap</span>();
    <span class="kw">let</span> <span class="ident">bt</span> <span class="op">=</span> <span class="ident">Backtrace</span>::<span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span><span class="ident">::recv</span>(<span class="kw-2">&amp;</span><span class="ident">hex::decode</span>(<span class="ident">bt_hex</span>).<span class="ident">unwrap</span>()).<span class="ident">unwrap</span>();
    <span class="kw">let</span> <span class="ident">elf_file_path</span> <span class="op">=</span> <span class="ident">matches</span>
        .<span class="ident">value_of</span>(<span class="string">&quot;file&quot;</span>)
        .<span class="ident">or</span>(<span class="ident">bt</span>.<span class="ident">preamble</span>.<span class="ident">image_path</span>.<span class="ident">as_ref</span>().<span class="ident">map</span>(<span class="ident">String::as_str</span>))
        .<span class="ident">expect</span>(<span class="string">&quot;ELF file neither embedded nor provided&quot;</span>);
    <span class="kw">let</span> <span class="ident">elf_file</span> <span class="op">=</span> <span class="ident">File::open</span>(<span class="ident">elf_file_path</span>).<span class="ident">unwrap</span>();
    <span class="kw">let</span> <span class="ident">map</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">Mmap::map</span>(<span class="kw-2">&amp;</span><span class="ident">elf_file</span>).<span class="ident">unwrap</span>() };
    <span class="kw">let</span> <span class="ident">elf_obj</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">object::File::parse</span>(<span class="kw-2">&amp;</span><span class="kw-2">*</span><span class="ident">map</span>).<span class="ident">unwrap</span>();
    <span class="kw">let</span> <span class="ident">ctx</span> <span class="op">=</span> <span class="ident">Context::new</span>(<span class="ident">elf_obj</span>).<span class="ident">unwrap</span>();
    <span class="ident">show_backtrace</span>(<span class="ident">ctx</span>, <span class="kw-2">&amp;</span><span class="ident">bt</span>, <span class="ident">elf_file_path</span>).<span class="ident">unwrap</span>();
}

<span class="kw">fn</span> <span class="ident">show_backtrace</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Reader</span><span class="op">&gt;</span>(
    <span class="ident">ctx</span>: <span class="ident">Context</span><span class="op">&lt;</span><span class="ident">R</span><span class="op">&gt;</span>,
    <span class="ident">bt</span>: <span class="kw-2">&amp;</span><span class="ident">Backtrace</span><span class="op">&lt;</span><span class="ident">String</span><span class="op">&gt;</span>,
    <span class="ident">elf_file_path</span>: <span class="kw-2">&amp;</span><span class="ident">str</span>,
) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), <span class="ident">gimli::Error</span><span class="op">&gt;</span> {
    <span class="macro">println!</span>(<span class="string">&quot;backtrace: {}&quot;</span>, <span class="ident">elf_file_path</span>);
    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">ref</span> <span class="ident">err</span>) <span class="op">=</span> <span class="ident">bt</span>.<span class="ident">postamble</span>.<span class="ident">error</span> {
        <span class="macro">println!</span>(<span class="string">&quot;    error: {:?}&quot;</span>, <span class="ident">err</span>);
    }
    <span class="kw">for</span> (<span class="ident">i</span>, <span class="ident">entry</span>) <span class="kw">in</span> <span class="ident">bt</span>.<span class="ident">entries</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">first</span> <span class="op">=</span> <span class="bool-val">true</span>;
        <span class="kw">let</span> <span class="ident">frame</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">entry</span>.<span class="ident">stack_frame</span>;
        <span class="comment">// TODO</span>
        <span class="comment">// let mut seen = false;</span>
        <span class="comment">// let initial_location = ctx.find_location(frame.ip as u64)?;</span>
        <span class="ident">ctx</span>.<span class="ident">find_frames</span>(<span class="ident">frame</span>.<span class="ident">ip</span> <span class="kw">as</span> <span class="ident">u64</span>)<span class="question-mark">?</span>.<span class="ident">for_each</span>(<span class="op">|</span><span class="ident">inner_frame</span><span class="op">|</span> {
            <span class="kw">if</span> <span class="ident">first</span> {
                <span class="macro">print!</span>(<span class="string">&quot; {:4}:  {:#18x} - &quot;</span>, <span class="ident">i</span>, <span class="ident">frame</span>.<span class="ident">ip</span>);
            } <span class="kw">else</span> {
                <span class="macro">print!</span>(<span class="string">&quot; {:4}   {:18  }   &quot;</span>, <span class="string">&quot;&quot;</span>, <span class="string">&quot;&quot;</span>);
            }
            <span class="comment">// TODO</span>
            <span class="comment">// if inner_frame.location == frame {</span>
            <span class="comment">//     seen = true;</span>
            <span class="comment">// }</span>
            <span class="kw">match</span> <span class="ident">inner_frame</span>.<span class="ident">function</span> {
                <span class="prelude-val">Some</span>(<span class="ident">f</span>) =&gt; {
                    <span class="comment">// TODO</span>
                    <span class="comment">// let raw_name = f.raw_name()?;</span>
                    <span class="comment">// let demangled = demangle(&amp;raw_name);</span>
                    <span class="kw">let</span> <span class="ident">demangled</span> <span class="op">=</span> <span class="ident">f</span>.<span class="ident">demangle</span>()<span class="question-mark">?</span>;
                    <span class="macro">print!</span>(<span class="string">&quot;{}&quot;</span>, <span class="ident">demangled</span>)
                }
                <span class="prelude-val">None</span> =&gt; <span class="macro">print!</span>(<span class="string">&quot;&lt;unknown&gt;&quot;</span>),
            }
            <span class="macro">print!</span>(<span class="string">&quot;\n&quot;</span>);
            <span class="comment">// TODO</span>
            <span class="comment">// if let Some(loc) = inner_frame.location {</span>
            <span class="comment">//     println!(&quot;      {:18}       at {}&quot;, &quot;&quot;, fmt_location(loc));</span>
            <span class="comment">// }</span>
            <span class="ident">first</span> <span class="op">=</span> <span class="bool-val">false</span>;
            <span class="prelude-val">Ok</span>(())
        })<span class="question-mark">?</span>;
        <span class="comment">// TODO this isn&#39;t accurate</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">loc</span>) <span class="op">=</span> <span class="ident">ctx</span>.<span class="ident">find_location</span>(<span class="ident">frame</span>.<span class="ident">ip</span> <span class="kw">as</span> <span class="ident">u64</span>)<span class="question-mark">?</span> {
            <span class="macro">println!</span>(<span class="string">&quot;      {:18}       at {}&quot;</span>, <span class="string">&quot;&quot;</span>, <span class="ident">fmt_location</span>(<span class="ident">loc</span>));
        }
        <span class="comment">// TODO</span>
        <span class="comment">// if !seen {</span>
        <span class="comment">//     print!(&quot;      &quot;);</span>
        <span class="comment">//     print!(&quot;warning: initial location missing: {}&quot;, initial_location);</span>
        <span class="comment">//     print!(&quot;\n&quot;);</span>
        <span class="comment">// }</span>
    }
    <span class="prelude-val">Ok</span>(())
}

<span class="kw">fn</span> <span class="ident">fmt_location</span>(<span class="ident">loc</span>: <span class="ident">addr2line::Location</span>) -&gt; <span class="ident">String</span> {
    <span class="macro">format!</span>(
        <span class="string">&quot;{} {},{}&quot;</span>,
        <span class="ident">loc</span>.<span class="ident">file</span>.<span class="ident">unwrap_or</span>(<span class="string">&quot;&lt;unknown&gt;&quot;</span>),
        <span class="ident">loc</span>.<span class="ident">line</span>
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="ident">to_string</span>())
            .<span class="ident">unwrap_or</span>(<span class="ident">String::from</span>(<span class="string">&quot;&lt;unknown&gt;&quot;</span>)),
        <span class="ident">loc</span>.<span class="ident">column</span>
            .<span class="ident">map</span>(<span class="op">|</span><span class="ident">x</span><span class="op">|</span> <span class="ident">x</span>.<span class="ident">to_string</span>())
            .<span class="ident">unwrap_or</span>(<span class="ident">String::from</span>(<span class="string">&quot;&lt;unknown&gt;&quot;</span>)),
    )
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_show_backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>